// cppepso.cpp : main EPSO C++ application
// Hrvoje Keko, INESC Porto, 09/2006 and 10/2008, and 03/2009
// + HydroWind Problem
//Erika Pequeno, Joana Hora, INESC Porto - INESC TEC, 01/2012


// STL headers
#include <iostream>
#include <fstream>
#include <iomanip>
#include <vector>
#include <list>

// EPSO header
#include "swarm.h"
#include "particle.h"
#include "myfitness.h"

#include <cstdlib>
#include <algorithm>

using std::rand;
using std::srand;
#include <ctime>
using std::time;



int main(int argc, char* argv[]) // todo : iterations without improvement
{
	clock_t start = clock();

	unsigned int i=0, numParticles=130, maxIter=23077;
	unsigned int num=8, temp=12;
	unsigned int dim=temp*num;
	bool minimize=false; // minimizing or maximizing
	

	HydroWind myFf;
	


	// now declare the swarm
	swarm epsoSwarm (numParticles, dim, num, minimize, myFf);

	//cout << setprecision(11);
	//cout << scientific;
	i=0; 

	//the results will be written in the outpuFile file
	//ofstream fitnessFile;
	//fitnessFile.open("fitnessFile.txt", ios_base::out | ios_base::app );
	//fitnessFile.precision(11);
	//ofstream fitnessFileExcel;
	//fitnessFileExcel.open("fitnessSEED.txt", ios_base::out | ios_base::app );
	//fitnessFileExcel.precision(11);



    // ***  main algorithm loop  ***
	// stopping criterion should be decided here
	while (i!=maxIter) // critrio de paragem: preciso pretendida /*(epsoSwarm.GetBestFitness() > 0.001) &&*/
	{
		i++;
		cout << " i:" << i << " f:" << epsoSwarm.GetBestFitness()<< " Euros"  << endl; 
		//fitnessFile << "iterations: " << i << " fitness evals: " << setprecision(11) << epsoSwarm.GetNumEvals() << " fitbest: " << setprecision(11) << epsoSwarm.GetBestFitness() << " Euros" << endl;
		//fitnessFileExcel << setprecision(11) << epsoSwarm.GetBestFitness() << endl;		
		epsoSwarm.NextIteration(i, maxIter, dim);
	}

	// print the number of iterations
	//cout << "iterations: " << i << " fitness evals: " << epsoSwarm.GetNumEvals() << " fitbest: " << epsoSwarm.GetBestFitness() << " Euros"  << endl;
	//cout<<endl;
	//fitnessFile.close();
	//fitnessFileExcel.close();

#if 0
	//ofstream bestSolutionFile;
	//bestSolutionFile.open("bestSolutionFile.txt", ios_base::out | ios_base::app );
	//bestSolutionFile.precision(11);
	ofstream bestSolutionFileExcel;
	bestSolutionFileExcel.open("bestSolution.txt", ios_base::out | ios_base::app );


	// display the final best solution on the screen
	//cout << endl << endl << " ==== best solution found ==== " << endl;
	for (i=0; i<dim; i++)
	{
		//cout << "x[" << i << "]=" << epsoSwarm.GetBestPos()[i] << endl;
		//bestSolutionFile << "x[" << i << "]= " << epsoSwarm.GetBestPos()[i] << endl;
		bestSolutionFileExcel << epsoSwarm.GetBestPos()[i] << endl;
	}
	bestSolutionFileExcel.close();
#endif

#if 0
	ofstream inercia;
	ofstream memoria;
	ofstream coperacao;
	ofstream perturbacao;
	inercia.open("inerciaSEED.txt", ios_base::out | ios_base::app );
	memoria.open("memoriaSEED.txt", ios_base::out | ios_base::app );
	coperacao.open("coperacaoSEED.txt", ios_base::out | ios_base::app );
	perturbacao.open("perturbacaoSEED.txt", ios_base::out | ios_base::app );
	for(i=0;i<(maxIter+1);i++)
	{
		inercia<<epsoSwarm.GetI()[i]<<endl;
		memoria<<epsoSwarm.GetM()[i]<<endl;
		coperacao<<epsoSwarm.GetC()[i]<<endl;
		perturbacao<<epsoSwarm.GetP()[i]<<endl;
	}

	//bestSolutionFile.close();
	inercia.close();
	memoria.close();
	coperacao.close();
	perturbacao.close();

	//cout<<endl;
#endif
	clock_t end = clock();
	clock_t millis = end - start;
	cout << "executing time: " << millis<< "milliseconds" << endl;


	return 0;
	
}






#if 0
	// best fitness output to .csv file
	ofstream outputFile;
	outputFile.open("output.txt", ios_base::out | ios_base::app );
	outputFile.precision(11);
	outputFile << scientific;
	outputFile << "iterations: " << i << " fitness evals: " << epsoSwarm.GetNumEvals() << " fitbest: " << epsoSwarm.GetBestFitness() << endl;
	for (i=0; i<dim; i++)
	{
	outputFile << "x[" << i << "]=" << epsoSwarm.GetBestPos()[i] << endl;
	}
	outputFile.close();

#endif