//=================================
// include guard
#pragma once

//=================================
// forward declared dependencies
class HWparticle; //keko dvida:: porque e que est esta classe aqui definida???

//=================================
// included dependencies
#include "particleHW.h"
#include <vector>
#include <armadillo>

//=================================
// namespaces
using namespace std;
using namespace arma;


//=================================
// type that defines pointer to comparison funciton depending whether the problem
// is minimization or maximization
typedef bool (* HWCompareFunction)(HWparticle&, HWparticle&); 

//=================================
// the HWfitnessfunction class
class HWfitnessfunction
{
private:
	//=================================
	bool Minimize; // sense of optimization - maximize or minimize
	//unsigned int dim;

public:
	//=================================
	HWfitnessfunction(void);

	//=================================
	HWCompareFunction particleCompare; // pointer to predicate function for comparison of two particles, used for sort
	
	//=================================
	HWCompareFunction equalParticles;//para verificar se as partculas so iguais

	//=================================
	//the most important member function is the following
	virtual double calcFitness(
					const fvec &variaveisProblema, 
					vector<double> Pos) = 0; // takes the vector and returns the value of fitness function double 

	//virtual double calcFitnessA(vector<double> Pos)= 0; 

	//=================================
	void HWSetMinimize(bool MinimizeFlag); // sets the flag regarding the optimization sense- minimize or maximize
	
	//=================================
	bool HWfitnessCompare(double fit1, double fit2); // comparison predicate function for doubles

	//para poder retirar as partculas iguais da lista das melhores
};

//=================================
bool HWparticle_compare_minimize(HWparticle &pP1, HWparticle &pP2); // comparison predicate function - minimization
bool HWparticle_compare_maximize(HWparticle &pP1, HWparticle &pP2); // comparison predicate function - maximization
